Magellan Linux

Annotation of /alx-src/trunk/alxinstall-ng/bin/alxinstall-ng.sh.in

Parent Directory Parent Directory | Revision Log Revision Log


Revision 6848 - (hide annotations) (download)
Thu Jul 23 14:03:36 2015 UTC (8 years, 9 months ago) by niro
File size: 24712 byte(s)
-revert changes, it is not the f2fs but the ext2 fs
1 niro 258 #!/bin/sh
2 niro 6819 # $Id$
3 niro 258
4 niro 6815 # ignore environment!
5     LC_ALL=C
6    
7 niro 6816 MLIBDIR="/usr/lib/alxinstall-ng"
8    
9 niro 6817 # images: (get ${CDIMAGENAME})
10 niro 258 source /mnt/cdrom/system/images.conf
11    
12 niro 6816 # includes
13 niro 6829 source ${MLIBDIR}/functions/generic.sh
14 niro 6816 source ${MLIBDIR}/functions/hwdetection.sh
15 niro 258
16     ### System/Config Version
17 niro 6820 VERSION="@@VERSION@@"
18 niro 258 TITLE="alxinstall-ng - ${VERSION}"
19    
20 niro 6825 # locations
21 niro 258 CDPATH="/mnt/cdrom"
22 niro 6835 INSTALL_ROOT="/mnt/magellan"
23 niro 258
24 niro 6825 # default system settings
25 niro 2555 # standard kernel opts
26 niro 6825 DEFAULT_KERNELOPTS="quiet video=1024x768"
27 niro 258
28 niro 2736 # grub options
29 niro 6825 DEFAULT_GRUBLEGACYOPTS=""
30     DEFAULT_GRUB2OPTS=""
31     DEFAULT_GRUB2GFXPAYLOAD="1024x768x16,1024x768"
32    
33     # default specialdevices
34     DEFAULT_FORMFACTOR="desktop"
35    
36     # target filesystem
37     DEFAULT_FORMAT_FILESYSTEM="ext4"
38    
39     # initialize global variables so they are exportable
40     INSTALL_METHOD=""
41     KERNELOPTS=""
42 niro 2736 GRUBLEGACYOPTS=""
43     GRUB2OPTS=""
44 niro 6825 GRUB2GFXPAYLOAD=""
45     FORMFACTOR=""
46     FORMAT_FILESYSTEM=""
47 niro 6841 FORMAT_FILESYSTEM_BOOTHDD=""
48     FORMAT_FILESYSTEM_ROOTHDD=""
49 niro 3199 FDISKPARTIONBELOW256MB=0
50 niro 1574 SPECIALDEVICE=""
51 niro 6837 FLASHDISK=0
52 niro 6825 ### linecount of system.tar.gz -1 !
53     CURRENTLINE=0
54     #TOTALLINES=11072 # -> now in images.conf
55 niro 1574
56 niro 258 #################################################
57 niro 6818 # DIALOG BOXES #
58 niro 258 #################################################
59    
60 niro 520 die()
61     {
62 niro 258 ERROR=$1
63     RETVAL=$?
64     dialog_install_failure
65 niro 6831 trap_exit
66 niro 258 exit 1
67     }
68    
69 niro 520 dialog_warning()
70     {
71 niro 258 dialog \
72 niro 520 --backtitle "${TITLE}" \
73 niro 258 --colors \
74     --defaultno \
75     --yesno "\Z1 !!! Achtung !!! \Zn\n\n\
76     Diese Festplatte wird unwiederruflich geloescht werden.\n\n\
77     Soll ich wirklich fortfahren ?" 10 70
78     RES=$?
79 niro 520 if [[ ${RES} -eq 1 ]]
80 niro 258 then
81     clear
82     echo "Der Vorgang wurde abgebrochen."
83     exit 1
84     fi
85     }
86    
87 niro 520 dialog_setup_hdd_info()
88     {
89 niro 6826 case "${INSTALL_METHOD}" in
90     auto)
91     dialog_setup_hdd_info_auto
92     dialog_setup_hdd_create_partitions
93     ;;
94     normal) dialog_setup_hdd_info_normal ;;
95     single) dialog_setup_hdd_info_single ;;
96 niro 6837 flash) dialog_setup_hdd_info_flash ;;
97 niro 6826 esac
98     }
99    
100     dialog_setup_hdd_info_normal()
101     {
102 niro 520 local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"
103 niro 258
104     dialog \
105     --colors \
106     --title "[ Festplatten Partitionierung ]" \
107 niro 520 --backtitle "${TITLE}" \
108 niro 258 --ok-label "Weiter" \
109     --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\
110     [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\
111     [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\
112     [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\
113     Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81
114     }
115    
116 niro 6823 dialog_setup_hdd_info_single()
117 niro 520 {
118     local SHDD="$(echo $HDD | sed 's/\/dev\///')"
119 niro 258
120 niro 280 dialog \
121     --colors \
122     --title "[ Festplatten Partitionierung ]" \
123 niro 520 --backtitle "${TITLE}" \
124 niro 280 --ok-label "Weiter" \
125     --msgbox "\nBitte legen Sie 1 Partition an.\n\n\
126     [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit dem gesamten Speicher\n\
127     Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81
128     }
129    
130 niro 6837 dialog_setup_hdd_info_flash()
131     {
132     local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"
133    
134     dialog \
135     --colors \
136     --title "[ Festplatten Partitionierung ]" \
137     --backtitle "${TITLE}" \
138     --ok-label "Weiter" \
139     --msgbox "\nBitte legen Sie 2 Partitionen an.\n\n\
140     [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\
141     [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\
142     Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81
143     }
144    
145 niro 1574 dialog_setup_hdd_info_auto()
146     {
147     local SHDD="$(echo $HDD | sed 's/\/dev\///')"
148    
149     dialog \
150     --colors \
151     --title "[ Festplatten Partitionierung ]" \
152     --backtitle "${TITLE}" \
153     --ok-label "Weiter" \
154     --msgbox "\nAchtung!\n\
155     Alle Daten werden von der Disk [ \Z3${HDD}\Zn ] gelöscht!" 12 81
156     }
157    
158 niro 520 dialog_setup_system_menu()
159     {
160     local i
161 niro 280
162 niro 520 i=$(dialog \
163     --backtitle "${TITLE}" \
164 niro 258 --title "[ Festplatten Partitionierung ]" \
165     --cancel-label "Abbrechen" \
166     --ok-label "Weiter" \
167     --stdout \
168 niro 1577 --colors \
169 niro 6842 --menu "\nWaehlen Sie die Installations-Methode" 14 70 6 \
170 niro 1577 "1" "Automatisches Setup (Empfohlen)" \
171     "" "" \
172 niro 1579 "" "\Z1Experten Modi:\Zn" \
173 niro 1577 "2" "Normale IDE-Disk (Manuell)" \
174 niro 6837 "3" "Normale IDE Disk (Single)" \
175     "4" "Flash SDHC/NAND oder USBStick (Manuell)")
176 niro 258 RES=$?
177 niro 520 [[ ${RES} -eq 1 ]] && return 1
178     if [[ ${RES} -eq 0 ]]
179     then
180     case "${i}" in
181 niro 6825 "1") run_install auto ;;
182     "2") run_install normal ;;
183     "3") run_install single ;;
184 niro 6843 "4") run_install flash ;;
185 niro 1577 "") dialog_setup_system_menu;;
186 niro 258 esac
187     fi
188     }
189    
190 niro 1574 dialog_hardware_detection()
191 niro 520 {
192     local i
193 niro 1574 local hwtmp
194 niro 258
195 niro 6838 if [ -x $(type -P mktemp) ]
196 niro 1574 then
197     hwtmp="$(mktemp)"
198     else
199     hwtmp="/tmp/hwtmp.sh"
200     fi
201    
202 niro 6816 run_hardware_detection_disks
203 niro 520
204 niro 1574 echo "dialog \\" > ${hwtmp}
205     echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}
206     echo "--ok-label \"Weiter\" \\" >> ${hwtmp}
207     echo "--stdout \\" >> ${hwtmp}
208     echo "--colors \\" >> ${hwtmp}
209     echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}
210     echo " Festplatten:\n \\" >> ${hwtmp}
211 niro 258
212 niro 6816 if [[ ! -z ${ALL_DISKS} ]]
213 niro 258 then
214 niro 6816 for i in ${ALL_DISKS}
215 niro 258 do
216 niro 6816 echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
217 niro 258 done
218     fi
219    
220 niro 6816 if [[ ! -z ${ALL_CDROMS} ]]
221 niro 258 then
222 niro 6816 echo " \n \\" >> ${hwtmp}
223     echo " CDROM Laufwerke:\n \\" >> ${hwtmp}
224     for i in ${ALL_CDROMS}
225 niro 258 do
226 niro 6816 echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
227 niro 258 done
228     fi
229    
230 niro 1574 # other devices
231     run_hardware_detection
232     case "${SPECIALDEVICE}" in
233 niro 6816 zotac*) echo " \n \\Z2Zotac Device erkannt.\\Zn \\" >> ${hwtmp} ;;
234     rangee) echo " \n \\Z2Rangee Device erkannt.\\Zn \\" >> ${hwtmp} ;;
235     maxdata) echo " \n \\Z2Maxdata Device erkannt.\\Zn \\" >> ${hwtmp} ;;
236     i845) echo " \n \\Z2Intel i845 Device erkannt.\\Zn \\" >> ${hwtmp} ;;
237     *) echo " \n \\ZnStandard Device erkannt.\\Zn \\" >> ${hwtmp} ;;
238 niro 1574 esac
239 niro 5003 if [[ ${FORMFACTOR} = laptop ]]
240     then
241 niro 5006 echo " \n \\ZnFormfactor Laptop, Powersave Modus 'ondemand' wird aktiviert.\\Zn \\" >> ${hwtmp}
242 niro 5003 fi
243 niro 6837 if [[ ${FLASHDISK} = 1 ]]
244     then
245     echo " \n \\ZnFlash Speicher erkannt, F2FS wird als Dateisystem benutzt.\\Zn \\" >> ${hwtmp}
246     fi
247 niro 1574
248 niro 5006 echo " \" 14 70" >> ${hwtmp}
249 niro 1574 chmod a+x ${hwtmp}
250     ${hwtmp}
251    
252     # remove tmp file
253     if [[ -f ${hwtmp} ]]
254     then
255     rm ${hwtmp}
256     fi
257 niro 258 }
258    
259 niro 6826 dialog_setup_hdd_partitions()
260 niro 520 {
261     local i
262    
263 niro 6816 if [[ -z ${ALL_DISKS} ]]
264 niro 258 then
265     dialog \
266 niro 520 --backtitle "${TITLE}" \
267 niro 258 --ok-label "Beenden" \
268     --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70
269     exit 1
270     else
271    
272     echo "dialog \\" > /tmp/hddtmp.sh
273 niro 520 echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh
274 niro 258 echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh
275     echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh
276     echo "--stdout \\" >> /tmp/hddtmp.sh
277     echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh
278    
279 niro 6816 for i in ${ALL_DISKS}
280 niro 258 do
281 niro 520 echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh
282 niro 258 done
283     echo -e "\n" >> /tmp/hddtmp.sh
284    
285     chmod a+x /tmp/hddtmp.sh
286 niro 520 HDD="$(/tmp/hddtmp.sh)"
287 niro 258 RES=$?
288 niro 520 [[ ${RES} -eq 1 ]] && return 1
289     if [[ ${RES} -eq 0 ]]
290 niro 258 then
291     dialog_setup_hdd_info
292 niro 6826 setup_hdd_partitions
293 niro 258 fi
294     fi
295     }
296    
297 niro 1574 dialog_setup_hdd_create_partitions()
298     {
299     dialog \
300     --backtitle "${TITLE}" \
301     --infobox "Erstelle Disk Partitionen ..." 3 70
302     }
303    
304 niro 520 dialog_setup_hdd_format()
305     {
306 niro 258 dialog \
307 niro 520 --backtitle "${TITLE}" \
308 niro 258 --infobox "Erstelle Datei-Systeme ..." 3 70
309     }
310    
311 niro 520 dialog_install_settings()
312     {
313 niro 258 dialog \
314 niro 520 --backtitle "${TITLE}" \
315 niro 258 --infobox "Speichere System-Einstellungen ..." 3 70
316     }
317    
318 niro 520 dialog_install_system_image()
319     {
320 niro 258 dialog \
321 niro 520 --backtitle "${TITLE}" \
322 niro 258 --gauge "Kopiere System-Image ..." 6 80
323     }
324    
325 niro 520 dialog_install_meter()
326     {
327     while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
328     do
329 niro 525 CURRENTLINE=$(grep -c . /tmp/install.log)
330     PERCENT=$(( ${CURRENTLINE} * 100 / ${TOTALLINES}))
331 niro 258 echo ${PERCENT}
332     sleep 1
333     done
334     rm -f /tmp/install.log
335     return 0
336     }
337    
338 niro 520 dialog_install_bootsector()
339     {
340 niro 258 dialog \
341 niro 520 --backtitle "${TITLE}" \
342 niro 258 --infobox "Schreibe den Bootsektor ..." 3 70
343     }
344    
345 niro 520 dialog_install_successful()
346     {
347 niro 258 dialog \
348 niro 520 --backtitle "${TITLE}" \
349 niro 258 --colors \
350     --msgbox "Die Installation war \Z2erfolgreich\Zn." 5 81
351     }
352    
353 niro 520 dialog_install_failure()
354     {
355 niro 258 dialog \
356 niro 520 --backtitle "${TITLE}" \
357 niro 258 --colors \
358     --msgbox "Die Installation ist \Z1Fehlgeschlagen\Zn.\n\n\
359 niro 520 Fehler bei ${ERROR}, RetVal: ${RETVAL} \
360 niro 258 " 10 81
361     }
362    
363 niro 520 dialog_main()
364     {
365 niro 258 METHOD=0
366    
367 niro 520 while [[ ${METHOD} -le 2 ]]
368 niro 258 do
369 niro 520 METHOD=$(dialog \
370     --backtitle "${TITLE}" \
371 niro 258 --no-cancel \
372     --ok-label "Weiter" \
373     --stdout \
374 niro 6842 --menu "Konfiguration" 14 70 6 \
375 niro 258 "1" "AutoSta_LX installieren" \
376     "2" "Uebersicht gefundener Laufwerke" \
377     "3" "Beenden und neustarten" \
378 niro 520 "4" "Beenden und eine Shell starten")
379 niro 258 RES=$?
380 niro 524 [[ ${RES} -eq 1 ]] && exit 1
381 niro 520 if [[ ${RES} -eq 0 ]]
382     then
383     case ${METHOD} in
384 niro 6770 "1") dialog_setup_system_menu ;;
385 niro 1574 "2") dialog_hardware_detection ;;
386 niro 520 "3") install_do_reboot ;;
387     "4") /bin/bash --login -i ;;
388 niro 258 esac
389     fi
390     done
391     }
392    
393     #################################################
394 niro 6818 # Install Commands #
395 niro 258 #################################################
396 niro 1574 run_hardware_detection()
397     {
398 niro 3199 local hwinfo
399 niro 5003 hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
400 niro 3199
401 niro 1574 # check for special devices/clients:
402     # if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
403     local removable=0
404 niro 3199 if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
405 niro 1574 then
406     for i in /sys/block/[hs]d*/removable
407     do
408     if [[ $(< ${i}) = 1 ]]
409     then
410     removable=1
411 niro 6837 # we assume that all removable disks are flash disks
412     export FLASHDISK=1
413 niro 1574 fi
414     done
415    
416 niro 2736 # only add this for grub legacy, grub2 detect these settings on its own
417     export GRUBLEGACYOPTS="rootdelay=8"
418 niro 5575 # there are two zotac types in the wild, nvidia based gfx and intel
419 niro 4847 if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
420     then
421     export SPECIALDEVICE="zotac_nvidia"
422     else
423     export SPECIALDEVICE="zotac_intel"
424     fi
425 niro 1574 fi
426 niro 3199
427     # check for special devices/clients:
428     # if a rangee and disk ist smaller then 256mb move partion one block further ahead
429     if [[ ! -z $(echo "${hwinfo}" | grep -i CLE266) ]]
430     then
431     # for a rangee always define partion startblock +1
432     export FDISKPARTIONBELOW256MB="1"
433     export SPECIALDEVICE="rangee"
434     export GRUBLEGACYOPTS=""
435     fi
436 niro 3260
437     # check for special devices/clients:
438     # check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer
439     if [[ ! -z $(echo "${hwinfo}" | grep -i i810) ]] || [[ ! -z $(echo "${hwinfo}" | grep -i i815) ]]
440     then
441     export SPECIALDEVICE="maxdata"
442     export GRUBLEGACYOPTS=""
443     fi
444 niro 5003
445 niro 5575 # check for i845 Chipsets and disable KMS and use 915 drm driver
446     if [[ ! -z $(echo "${hwinfo}" | grep -i i845) ]]
447     then
448     export SPECIALDEVICE="i845"
449     # unset default video=1024x768 opt or the drm driver breaks
450     export KERNELOPTS="quiet"
451     export GRUBLEGACYOPTS=""
452     # enable full kms support
453     export GRUB2GFXPAYLOAD="keep"
454     fi
455    
456 niro 6771 # check for radeon gfxcards
457     if [[ ! -z $(echo "${hwinfo}" | grep -i radeon) ]]
458     then
459     # enable full kms support
460     export GRUB2GFXPAYLOAD="keep"
461     fi
462    
463 niro 5003 # check for special devices/clients:
464     # check for laptops and activate cpufreq scaling
465     if [[ $(echo "${hwinfo}" | grep 'Formfactor:' | sed 's:.*Formfactor\:\ \"\(.*\)\":\1:') = laptop ]]
466     then
467     export FORMFACTOR="laptop"
468     export KERNELOPTS="${KERNELOPTS} cpufreq.governor=ondemand"
469     fi
470 niro 1574 }
471    
472 niro 6816 run_hardware_detection_disks()
473     {
474     local bootdev
475    
476     # all disks but exclude ramdisks
477     export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
478     # remove the boot device from ALL_DISKS if it was an usbstick
479     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
480     then
481     bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
482     export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
483     fi
484     export ALL_CDROMS="$(get_hwinfo cdrom)"
485     }
486    
487 niro 3199 hdd_size_below_256mb()
488     {
489     local hdd="$1"
490     local size
491     local retval
492     [[ -z ${hdd} ]] && die "Error: get_hdd_size() no \$hdd given!"
493    
494     size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')
495     if [[ ${size} -le 257000000 ]]
496     then
497     retval="0"
498     else
499     retval="1"
500     fi
501    
502     return "${retval}"
503     }
504    
505 niro 6826 setup_hdd_partitions()
506 niro 1574 {
507 niro 6826 case "${INSTALL_METHOD}" in
508     normal)
509     BOOTHDD="${HDD}1"
510     SWAPHDD="${HDD}2"
511     ROOTHDD="${HDD}3"
512     ;;
513 niro 1574
514 niro 6826 single|auto)
515 niro 6827 BOOTHDD=""
516     SWAPHDD=""
517 niro 6826 ROOTHDD="${HDD}1"
518     ;;
519 niro 6837
520     flash)
521     BOOTHDD="${HDD}1"
522     SWAPHDD=""
523     ROOTHDD="${HDD}2"
524     ;;
525 niro 6826 esac
526    
527     if [[ ${INSTALL_METHOD} = auto ]]
528 niro 3199 then
529 niro 6826 # run this only if FDISKPARTITIONBELOW256MB is not already 1
530     if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
531 niro 3199 then
532 niro 6826 if hdd_size_below_256mb ${HDD}
533     then
534     FDISKPARTIONBELOW256MB=1
535     else
536     FDISKPARTIONBELOW256MB=0
537     fi
538 niro 3199 fi
539    
540 niro 6826 ## delete disk
541     dd if=/dev/zero of=${HDD} count=1 &> /dev/null || die
542 niro 1574
543 niro 6846 if [[ ${FLASHDISK} = 1 ]]
544 niro 6826 then
545 niro 6846 if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
546     then
547     ## setup one bootable partition
548     # 1. n= new disk
549     # 2. p= primary disk
550     # 3. 1= first partition
551     # 4. 2= default sector start // small disk needs more space for grub2 mbr sector
552     # 5. ''= defaul sector end
553     # 6. a= bootable flag
554     # 7. 1= boot flag for partition 1
555     # 8. n= new disk
556     #10. p= primary disk
557     #11. 2= second partition
558     #12. ''= default sector start
559     #13. ''= defaul sector end
560     #14. w= write/quit
561     fdisk ${HDD} &> /dev/null << EOF
562 niro 1574 n
563     p
564     1
565 niro 3199 2
566 niro 6848 +50M
567 niro 6846 a
568     1
569     n
570     p
571     2
572 niro 1574
573 niro 6846
574     w
575     EOF
576     else
577     ## setup one bootable partition
578     # 1. n= new disk
579     # 2. p= primary disk
580     # 3. 1= first partition
581     # 4. ''= default sector start
582     # 5. ''= defaul sector end
583     # 6. a= bootable flag
584     # 7. 1= boot flag for partition 1
585     # 8. n= new disk
586     #10. p= primary disk
587     #11. 2= second partition
588     #12. ''= default sector start
589     #13. ''= defaul sector end
590     #14. w= write/quit
591     fdisk ${HDD} &> /dev/null << EOF
592     n
593     p
594     1
595    
596 niro 6848 +50M
597 niro 3199 a
598     1
599 niro 6846 n
600     p
601     2
602    
603    
604 niro 3199 w
605     EOF
606 niro 6846 fi
607 niro 6826 else
608 niro 6846 if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
609     then
610     ## setup one bootable partition
611     #1. n= new disk
612     #2. p= primary disk
613     #3. 1= first partition
614     #4. 2= default sector start // small disk needs more space for grub2 mbr sector
615     #5. ''= defaul sector end
616     #6. a= bootable flag
617     #7. 1= boot flag for partition 1
618     #8. w= write/quit
619     fdisk ${HDD} &> /dev/null << EOF
620 niro 3199 n
621     p
622     1
623 niro 6846 2
624 niro 1574
625 niro 6846 a
626     1
627     w
628     EOF
629     else
630     ## setup one bootable partition
631     #1. n= new disk
632     #2. p= primary disk
633     #3. 1= first partition
634     #4. ''= default sector start
635     #5. ''= defaul sector end
636     #6. a= bootable flag
637     #7. 1= boot flag for partition 1
638     #8. w= write/quit
639     fdisk ${HDD} &> /dev/null << EOF
640     n
641     p
642     1
643 niro 3199
644 niro 6846
645 niro 1574 a
646     1
647     w
648     EOF
649 niro 6846 fi
650 niro 6826 fi
651     else
652     ## hdds partitionieren manuell
653     cfdisk ${HDD} || die
654 niro 3199 fi
655 niro 1574 }
656    
657 niro 520 setup_hdd_format()
658     {
659 niro 6844 install -d /tmp
660     :> /tmp/format.log
661    
662 niro 6825 if [[ -n ${SWAPHDD} ]]
663     then
664     mkswap ${SWAPHDD} || die
665     fi
666     if [[ -n ${BOOTHDD} ]]
667     then
668 niro 6844 mkfs.${FORMAT_FILESYSTEM_BOOTHDD} ${BOOTHDD} &> /tmp/format.log || die
669 niro 6825 fi
670     if [[ -n ${ROOTHDD} ]]
671     then
672 niro 6844 mkfs.${FORMAT_FILESYSTEM_ROOTHDD} ${ROOTHDD} &> /tmp/format.log || die
673 niro 6825 fi
674 niro 258 }
675    
676 niro 520 install_mount_rootfs()
677     {
678 niro 6837 local opts
679    
680 niro 6825 if [[ -n ${SWAPHDD} ]]
681     then
682     swapon ${SWAPHDD} || die
683     fi
684     if [[ -n ${ROOTHDD} ]]
685     then
686 niro 6841 mount -t ${FORMAT_FILESYSTEM_ROOTHDD} ${ROOTHDD} ${INSTALL_ROOT} || die
687 niro 6825 fi
688     if [[ -n ${BOOTHDD} ]]
689     then
690 niro 6835 install -d ${INSTALL_ROOT}/boot || die
691 niro 6841 mount -t ${FORMAT_FILESYSTEM_BOOTHDD} ${BOOTHDD} ${INSTALL_ROOT}/boot || die
692 niro 6825 fi
693 niro 258
694 niro 6835 cd ${INSTALL_ROOT} || die
695 niro 280 }
696    
697 niro 520 install_system_image()
698     {
699 niro 6835 tar xvjpf ${CDPATH}/system/${CDIMAGENAME} -C ${INSTALL_ROOT}
700 niro 258 }
701    
702 niro 520 install_bootsector_chroot()
703     {
704 niro 1574 local my_roothdd
705 niro 6835 local grubconf=${INSTALL_ROOT}/boot/grub/grub.conf
706 niro 2573 local grub2conf=/boot/grub/grub.cfg
707 niro 6834 local CONFIG
708 niro 1574
709 niro 2554 # check for grub2
710 niro 6835 if [[ -f ${INSTALL_ROOT}/sbin/grub-mkconfig ]]
711 niro 258 then
712 niro 2554 # needed by grub-mkconfig on the first run
713 niro 6835 if [[ ! -f ${INSTALL_ROOT}/boot/grub/video.lst ]]
714 niro 2554 then
715 niro 6835 install -m0644 ${INSTALL_ROOT}/lib/grub/*/video.lst ${INSTALL_ROOT}/boot/grub/video.lst || die
716 niro 2554 fi
717 niro 522
718 niro 2557 # set kernelopts
719 niro 6835 if [[ -f ${INSTALL_ROOT}/etc/conf.d/grub ]]
720 niro 2557 then
721 niro 6835 sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALL_ROOT}/etc/conf.d/grub || die
722     sed -i "s:^\(export GRUB_GFXPAYLOAD_LINUX=\).*:\1\"${GRUB2GFXPAYLOAD}\":" ${INSTALL_ROOT}/etc/conf.d/grub || die
723 niro 2557 else
724 niro 6839 CONFIG=${INSTALL_ROOT}/etc/conf.d/grub
725     clearconfig
726     addconfig "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\""
727     addconfig "export GRUB_GFXPAYLOAD_LINUX=\"${GRUB2GFXPAYLOAD}\""
728 niro 2557 fi
729 niro 6835 CONFIG=${INSTALL_ROOT}/.installrc
730 niro 6834 clearconfig
731     addconfig 'grub-mkdevicemap'
732     addconfig "LC_ALL=C grub-mkconfig -o ${grub2conf} &> /dev/null"
733     addconfig "grub-install --no-floppy ${HDD} &> /dev/null"
734     addconfig "exit 0"
735 niro 2557
736 niro 2554 # grub-legacy
737 niro 1574 else
738 niro 2554 ### grubconf schreiben
739 niro 6835 source ${INSTALL_ROOT}/boot/kernelversion
740 niro 1574
741 niro 2554 #for alx only
742 niro 6835 if [ -e ${INSTALL_ROOT}/etc/alx_version ]
743 niro 2554 then
744     OLD_ALXVER="${ALXVER}"
745 niro 6835 source ${INSTALL_ROOT}/etc/alx_version
746 niro 2554 KRNVER="ALX-${ALXVER}"
747     ALXVER="${OLD_ALXVER}"
748     fi
749 niro 522
750 niro 2554 [[ -z ${KRNVER} ]] && KRNVER="AutoSta_LX"
751     [[ -z ${KRNINITRD} ]] && KRNINITRD="initrd"
752     [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"
753 niro 1123
754 niro 2554 # uuid support
755     if is_uuid_supported
756     then
757     my_roothdd="UUID=$(get_uuid ${ROOTHDD})"
758     else
759     my_roothdd="${ROOTHDD}"
760     fi
761 niro 1123
762 niro 6834 CONFIG="${grubconf}"
763     clearconfig
764     addconfig "default 0"
765     addconfig "timeout 3"
766 niro 2554 # using current root password
767 niro 6835 addconfig "password --md5 $(cat ${INSTALL_ROOT}/etc/shadow | grep root | cut -d: -f2)"
768 niro 6834 addconfig
769     addconfig "# normal boot"
770     addconfig "title ${KRNVER}"
771     addconfig "root (hd0,0)"
772     addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}"
773 niro 2554 if is_initrd_supported
774     then
775 niro 6834 addconfig "initrd /boot/${KRNINITRD}"
776 niro 2554 fi
777 niro 6834 addconfig
778     addconfig "# admin boot"
779     addconfig "title ${KRNVER} - Re-run hardware-detection"
780     addconfig "lock"
781     addconfig "root (hd0,0)"
782     addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection"
783 niro 2554 if is_initrd_supported
784     then
785 niro 6834 addconfig "initrd /boot/${KRNINITRD}"
786 niro 2554 fi
787 niro 6834 addconfig
788     addconfig "title ${KRNVER} - Reset *all* local settings"
789     addconfig "lock"
790     addconfig "root (hd0,0)"
791     addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings"
792 niro 2554 if is_initrd_supported
793     then
794 niro 6834 addconfig "initrd /boot/${KRNINITRD}"
795 niro 2554 fi
796    
797 niro 6818 # write bootsector chrooted (lfs/magellan)
798 niro 6835 CONFIG=${INSTALL_ROOT}/.installrc
799 niro 6834 clearconfig
800     addconfig '/usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null'
801     addconfig 'root (hd0,0)'
802     addconfig 'setup (hd0)'
803     addconfig 'quit'
804     addconfig 'EOF'
805     addconfig 'exit 0'
806 niro 2554 fi
807 niro 528
808 niro 6834 ## enter chroot
809     enter_chroot_installrc
810 niro 528 }
811    
812 niro 1574 is_initrd_supported()
813 niro 528 {
814 niro 1574 # only generate initrds if the cmd exists
815 niro 6835 [[ -x ${INSTALL_ROOT}/sbin/mkinitrd ]] && return 0
816 niro 1574 return 1
817     }
818    
819     install_initrd_chroot()
820     {
821 niro 6829 local CONFIG
822    
823 niro 1574 # only generate initrds if the cmd exists
824     is_initrd_supported || return 0
825    
826 niro 6841 FSMODS="${FORMAT_FILESYSTEM_BOOTHDD} ${FORMAT_FILESYSTEM_ROOTHDD}"
827 niro 2573 DISKMODS="sd_mod"
828     OLDPATAMODS="amd74xx piix sis5513 via82cxxx"
829     PATAMODS="ata_piix pata_amd pata_mpiix pata_oldpiix pata_sis pata_via"
830     SATAMODS="sata_via sata_sis sata_nv"
831     DRMMODS="i915 mga nouveau r128 radeon savage sis tdfx ttm via"
832 niro 5003 OTHERMODS=""
833 niro 3202 case ${SPECIALDEVICE} in
834 niro 5575 zotac_intel|i845) FBMODS=""; DRMMODS="i915" ;;
835 niro 4847 zotac_nvidia) FBMODS=""; DRMMODS="nouveau" ;;
836 niro 3256 rangee) FBMODS="" ;; ## fallback to vesafb, viafb does not run on all CLE266 boards
837 niro 4853 # not working with kms enabled drivers -> segfaults
838     #maxdata) FBMODS="i810fb" ;; ## check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer
839     maxdata) FBMODS="" ;;
840 niro 3202 *) FBMODS="uvesafb" ;;
841     esac
842 niro 2573
843 niro 5003 if [[ ${FORMFACTOR} = laptop ]]
844     then
845     OTHERMODS="acpi-cpufreq cpufreq_ondemand cpufreq_conservative cpufreq_powersave"
846     fi
847    
848 niro 2573 # install an appropriate uvesafb.conf
849 niro 6835 CONFIG=${INSTALL_ROOT}/etc/modprobe.d/uvesafb.conf
850 niro 6829 clearconfig
851     addconfig "options uvesafb mode_option=1024x768-32@60 scroll=ywrap"
852 niro 2573
853 niro 3202 # install an appropriate viafb.conf
854 niro 6835 CONFIG=${INSTALL_ROOT}/etc/modprobe.d/viafb.conf
855 niro 6829 clearconfig
856     addconfig "options viafb viafb_mode=1024x768 viafb_refresh=60"
857 niro 3202
858 niro 3260 # install an appropriate i810fb.conf
859 niro 6835 CONFIG=${INSTALL_ROOT}/etc/modprobe.d/i810fb.conf
860 niro 6829 clearconfig
861     addconfig "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"
862 niro 3260
863 niro 6835 CONFIG=${INSTALL_ROOT}/.installrc
864 niro 6834 clearconfig
865 niro 6837 addconfig 'echo "MODULES=\"${FSMODS} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd'
866 niro 6834 addconfig 'mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null'
867     addconfig 'exit 0'
868 niro 6832 ## enter chroot
869 niro 6834 enter_chroot_installrc
870 niro 258 }
871    
872 niro 1574 is_uuid_supported()
873 niro 1180 {
874 niro 6837 # f2fs needs special treatments as the old busybox does not support this fs
875     # use the blkid from util-linux instead of busybox
876     if [[ ${FORMAT_FILESYSTEM} = f2fs ]]
877 niro 1574 then
878 niro 6838 if [[ -x $(type -P blkid) ]]
879 niro 1574 then
880 niro 6837 return 0
881 niro 1574 fi
882 niro 6837 else
883 niro 6838 if [[ -x $(type -P busybox.mkinitrd) ]]
884 niro 6837 then
885     # only detect uuids if supported
886     if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]
887     then
888     return 0
889     fi
890     fi
891 niro 1574 fi
892    
893     return 1
894     }
895    
896     get_uuid()
897     {
898 niro 1180 local UUID
899     local SEC_TYPE
900     local TYPE
901 niro 6837 local blkidcmd
902 niro 1574
903 niro 1180 local dev="$1"
904     [[ -z ${dev} ]] && die "no dev given"
905    
906 niro 1187 # check if given device is already an UUID
907     if [[ ${dev/UUID=/}x != ${dev}x ]]
908     then
909     eval "${dev}"
910     else
911 niro 6837 # f2fs needs special treatments as the old busybox does not support this fs
912     # use the blkid from util-linux instead of busybox
913     if [[ ${FORMAT_FILESYSTEM} = f2fs ]]
914     then
915     blkidcmd="blkid"
916     else
917     blkidcmd="busybox.mkinitrd blkid"
918     fi
919     eval $(${blkidcmd} ${dev} | grep "${dev}:" | sed 's/.*:\ //')
920 niro 1187 fi
921 niro 1574 echo "${UUID}"
922 niro 1180 }
923    
924 niro 520 install_system_settings()
925     {
926 niro 6839 local CONFIG
927 niro 6840 local fstype
928 niro 6839
929     # write fstab
930     CONFIG=${INSTALL_ROOT}/etc/fstab
931     clearconfig
932 niro 6840
933     if [[ -n ${BOOTHDD} ]]
934 niro 1574 then
935 niro 6840 if is_uuid_supported
936 niro 6825 then
937 niro 6841 addconfig -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM_BOOTHDD}\tnoatime,noauto\t1 1"
938 niro 6840 else
939 niro 6841 addconfig -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM_BOOTHDD}\tnoatime,noauto\t1 1"
940 niro 6825 fi
941 niro 6840 fi
942    
943     if [[ -n ${ROOTHDD} ]]
944     then
945     if is_uuid_supported
946 niro 6825 then
947 niro 6841 addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM_ROOTHDD}\tnoatime\t0 0"
948 niro 6840 else
949 niro 6841 addconfig -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM_ROOTHDD}\tnoatime\t0 0"
950 niro 6825 fi
951 niro 1574 fi
952 niro 6840
953 niro 1187 # not needed busybox loads all with swapon -a, even if not mentioned in fstab
954 niro 6839 #addconfig -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0"
955     addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
956     addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
957 niro 531
958     # install network config skeleton
959 niro 6835 install -m0644 ${INSTALL_ROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALL_ROOT}/etc/conf.d/ || die
960 niro 3374
961     # intel framebufer quirk
962     if [[ -e /proc/fb ]]
963     then
964     if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
965     then
966     fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
967     if [[ ${fbdev} != 0 ]]
968     then
969 niro 6835 sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALL_ROOT}/etc/splash/splash.conf || die
970 niro 3374 fi
971     fi
972     fi
973 niro 258 }
974    
975 niro 6825 install_umount_rootfs()
976 niro 520 {
977 niro 6825 cd /
978     if [[ -n ${BOOTHDD} ]]
979 niro 1574 then
980 niro 6835 umount ${INSTALL_ROOT}/boot || die
981 niro 1574 fi
982 niro 6825 if [[ -n ${ROOTHDD} ]]
983     then
984 niro 6835 umount ${INSTALL_ROOT} || die
985 niro 6825 fi
986     if [[ -n ${SWAPHDD} ]]
987     then
988     swapoff ${SWAPHDD} || die
989     fi
990 niro 280 }
991 niro 520
992     install_do_reboot()
993     {
994 niro 258 reboot
995     }
996    
997     #################################################
998 niro 6818 # Install Main Scripts #
999 niro 258 #################################################
1000    
1001 niro 6825 run_install()
1002 niro 520 {
1003 niro 6825 local method="$1"
1004    
1005     # setup install environment
1006     export KERNELOPTS="${DEFAULT_KERNELOPTS}"
1007     export GRUBLEGACYOPTS="${GRUBLEGACYOPTS}"
1008     export GRUB2OPTS="${GRUB2OPTS}"
1009     export GRUB2GFXPAYLOAD="${DEFAULT_GRUB2GFXPAYLOAD}"
1010     export FORMFACTOR="${DEFAULT_FORMFACTOR}"
1011     export FORMAT_FILESYSTEM="${DEFAULT_FORMAT_FILESYSTEM}"
1012    
1013     case "${method}" in
1014     auto)
1015 niro 6846 if [[ ${FLASHDISK} = 1 ]]
1016     then
1017     export FORMAT_FILESYSTEM="f2fs"
1018     export FORMAT_FILESYSTEM_BOOTHDD="ext2"
1019     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
1020     else
1021     export FORMAT_FILESYSTEM_BOOTHDD=""
1022     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
1023     fi
1024 niro 6825 export INSTALL_METHOD="${method}"
1025     ;;
1026     normal)
1027 niro 6841 export FORMAT_FILESYSTEM_BOOTHDD="${FORMAT_FILESYSTEM}"
1028     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
1029 niro 6825 export INSTALL_METHOD="${method}"
1030     ;;
1031     single)
1032 niro 6841 export FORMAT_FILESYSTEM_BOOTHDD=""
1033     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
1034 niro 6825 export INSTALL_METHOD="${method}"
1035     ;;
1036 niro 6837 flash)
1037     export FORMAT_FILESYSTEM="f2fs"
1038 niro 6841 export FORMAT_FILESYSTEM_BOOTHDD="ext2"
1039     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
1040 niro 6837 export INSTALL_METHOD="${method}"
1041     ;;
1042 niro 6825 *)
1043 niro 6843 die "Unknown install method '${method}', aborting."
1044 niro 6825 ;;
1045     esac
1046    
1047 niro 1574 dialog_hardware_detection
1048 niro 520
1049 niro 6826 dialog_setup_hdd_partitions
1050 niro 258 dialog_setup_hdd_format
1051     setup_hdd_format > /dev/null
1052     install_mount_rootfs
1053     (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image
1054 niro 520
1055 niro 258 dialog_install_settings
1056     sleep 1
1057     install_system_settings
1058 niro 1574 install_initrd_chroot
1059 niro 2554
1060     dialog_install_bootsector
1061     install_bootsector_chroot
1062    
1063 niro 258 install_umount_rootfs
1064     dialog_install_successful
1065     }
1066    
1067 niro 6831 # set some proper traps
1068     trap "trap_exit" SIGINT SIGQUIT
1069    
1070 niro 522 dialog_main
1071 niro 258
1072     exit 0